//=========================================================================
//	X~NX	[ k_sumi.cpp ]
//	쐬F2017/06/05
//	쐬ҁF
//=========================================================================
#include	"k_sumigame.h"
#include	"main.h"
#include	<time.h>
#include	"renderer.h"
//#include	"manager.h"
#include	"camera.h"
#include	"light.h"

//=========================================================================
//	萔`
//=========================================================================
#define NUM_VERTEX (4)								// _
#define NUM_INDEX  (6)								// _CfbNX

//J̎dlႩꍇAύXăp[eBN
#define ROT_KAMERA_Y	( 180.0f )							
	
#define NUM_POLYGON (2)								// |S

#define TEXTURENAME "data/TEXTURE/smoke.jpg"

#define PARTICLE_LIFE ( 100 )						// GtFNg̎

#define PARTICLE_RADIUS (30)						// wi̕

#define RADIAN(arc) (((arc) * D3DX_PI ) / 180)		// WǍvZɕKv

#define SAFE_RELEASE(p) { if (p) { (p)->Release(); (p)=NULL; } }

//=========================================================================
//	
//=========================================================================
void	KSumiGame::Init( void )
{
	// foCX󂯎p֐
	LPDIRECT3DDEVICE9 pDevice = GetDevice( );


	// _̏
	srand( ( unsigned int ) time( NULL ) );

	// p[eBNXe[^X̏
	for( int index = 0; index < PARTICLE_MAX ; index++ ){

		m_aParticle[ index ].center   = D3DXVECTOR3( 10.0f, 10.0f, 100.0f );
		m_aParticle[ index ].speed    = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
		m_aParticle[ index ].velocity = D3DXVECTOR3( 1.0f, 1.0f, 1.0f );
		//m_aParticle[ index ].scale    = D3DXVECTOR3( 1.0f, 1.0f, 1.0f );

		m_aParticle[ index ].life     = 0.0f; 
		m_aParticle[ index ].age      = 0.0f;
		m_aParticle[ index ].radius   = 30.0f;
		m_aParticle[ index ].color    = D3DXCOLOR( 0.5f, 0.2f, 0.8f, 1.0f ); 

		m_aParticle[ index ].ambientPower = D3DXVECTOR3( 0, 0 ,0 );
		//m_aParticle[ index ].texIndex = 0;				// TEXTUREftHgݒ

	} // -> INTIALIZE PARTICLE


	// _obt@̍쐬
	MakeVertex( pDevice );

	// eNX`̓ǂݍ 
	//for( int index = 0; index < NUM_TEXTURE; index++ ){
	HRESULT hres = D3DXCreateTextureFromFile( pDevice, TEXTURENAME, &m_pTexture );
	if( FAILED( hres ))
	{
		#ifdef _DEBUG
		MessageBox( NULL, "eNX`t@C̓ǂݍ݂Ɏs܂!" , "TEXTURE LOAD ERROR!!", MB_OK | MB_ICONWARNING );
		#endif	// _DEBUG
	}
}
	
//=========================================================================
//	I
//=========================================================================
// p[eBNI
void KSumiGame::Uninit( void )
{
	// eNX`C^[tF[X̊J
	SAFE_RELEASE( m_pTexture )

	// CfbNXobt@̊J
	//SAFE_RELEASE( m_pIndexBuffer )

	// _obt@C^[tF[X̊J
	SAFE_RELEASE( m_pVtxBuffer )
}

//=========================================================================
//	XV
//=========================================================================
void	KSumiGame::Update( void )
{
		VERTEX_3D* pVtx;

	// obt@bNzAhX擾
	m_pVtxBuffer -> Lock(0,0,(void**)&pVtx,0 );


	// p[eBN̍XV
	for( int index = 0; index < PARTICLE_MAX; index++ ){

		if( m_aParticle[ index ].life ){


			{ // p[eBNp[^[̍XV

				// p[eBN݃t[̍XV
				m_aParticle[ index ].life -= 1 ;
				m_aParticle[ index ].age  += 1;

				// F̐ݒ
				m_aParticle[ index ].color.r -= m_aParticle[ index ].amountOfChangeInColor.r;
				m_aParticle[ index ].color.g -= m_aParticle[ index ].amountOfChangeInColor.g;
				m_aParticle[ index ].color.b -= m_aParticle[ index ].amountOfChangeInColor.b;
				m_aParticle[ index ].color.a -= m_aParticle[ index ].amountOfChangeInColor.a;
				if( m_aParticle[ index ].color.a < 0.0f ){
					m_aParticle[ index ].color.a = 0.0f;
				}

				// x̉Z
				m_aParticle[ index ].speed.x *= m_aParticle[ index ].velocity.x;
				m_aParticle[ index ].speed.y *= m_aParticle[ index ].velocity.y;
				m_aParticle[ index ].speed.z *= m_aParticle[ index ].velocity.z;

				// p[eBN̈ړ
				m_aParticle[ index ].center.x += m_aParticle[ index ].speed.x*sinf( m_aParticle[index].theta )*cosf( m_aParticle[index].phy );
				m_aParticle[ index ].center.y += m_aParticle[ index ].speed.y*cosf( m_aParticle[index].theta );
				m_aParticle[ index ].center.z += m_aParticle[ index ].speed.z*sinf( m_aParticle[index].theta )*sinf( m_aParticle[index].phy );

				// ͂ɂxNgϊ
				/*if( particle[ index ].age > 10 ){
					particle[ index ].center += particle[ index ].ambientPower;
				}*/

				// GtFNg̐ݒu
				SetVertexColor( pVtx, index );
				SetVertexCoord( pVtx, index );

			} // -> END ( PARTICLE UPDATE )
		}	// if( particle[ index ].life ) -> END
	}	// for -> END



	// obt@̃AbN
	m_pVtxBuffer->Unlock();


}

//=========================================================================
//	`
//=========================================================================	
void	KSumiGame::Draw( void )
{
	// foCX̎󂯎
	LPDIRECT3DDEVICE9 pDevice = GetDevice( );

	// Wϊ[hs
	D3DXMATRIX mtxWorld;
	D3DXMATRIX mtxTranslation;
	D3DXMATRIX mtxRotarion;
	//DXMATRIX mtxScale;

	// Cg
	pDevice ->SetRenderState( D3DRS_LIGHTING, false );

	
	pDevice ->SetRenderState( D3DRS_BLENDOP, D3DBLENDOP_REVSUBTRACT );
	pDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA );	
	pDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );
	
	pDevice ->SetRenderState( D3DRS_ZWRITEENABLE, false );

	// Xg[
	pDevice->SetStreamSource(0,					
		m_pVtxBuffer,								
		0,													
		sizeof( VERTEX_3D ));						

	// _tH[}bg̐ݒ
	pDevice->SetFVF( FVF_VERTEX_3D );


	// p[eBN̕`
	for( int index = 0; index < PARTICLE_MAX; index++ ){

		if( m_aParticle[ index ].life ){

			// Pʍsւ̏( sPʍsɂ )
			D3DXMatrixIdentity( &mtxWorld );

			D3DXMatrixRotationYawPitchRoll( &mtxRotarion , 90.0f , 0.0f , 0.0f );
			D3DXMatrixTranslation( &mtxTranslation, m_aParticle[index].center.x, m_aParticle[index].center.y, m_aParticle[index].center.z );

			//mtxTranslation *= mtxRotarion;

			mtxWorld = Camera::GetMtxView( ) * mtxTranslation ;

			// foCXɃ[hϊsݒ
			pDevice ->SetTransform( D3DTS_WORLD, &mtxWorld );

			// eNX`̐ݒ
			pDevice->SetTexture( 0, m_pTexture );
		
			// `揈
			pDevice ->DrawPrimitive( D3DPT_TRIANGLESTRIP, NUM_VERTEX*index, NUM_POLYGON );
		
		}
	}


	// ̏Ԃɖ߂
	pDevice ->SetRenderState( D3DRS_ZWRITEENABLE, true );

	//pDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA );
	pDevice->SetRenderState( D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA );


		pDevice->SetRenderState( D3DRS_BLENDOP, D3DBLENDOP_ADD );

	pDevice ->SetRenderState( D3DRS_LIGHTING, true );
}

//=========================================================================
// _̍쐬
//=========================================================================
HRESULT KSumiGame::MakeVertex( LPDIRECT3DDEVICE9 pDevice )
{


VERTEX_3D *pVtx;												// zAhX

	if(FAILED(pDevice->CreateVertexBuffer(
		sizeof(VERTEX_3D) * NUM_VERTEX * PARTICLE_MAX,	// mۂobt@TCY(_m) P:oCg
			D3DUSAGE_WRITEONLY,										// gp@
			FVF_VERTEX_3D,											// gp钸_tH[}bg(ȏȂQƂȂ̂0ł悢)
			D3DPOOL_MANAGED,										// obt@̊Ǘ@(obt@̒ɏ񂾂̂̊Ǘ@)
			&m_pVtxBuffer,									// i[|C^
			NULL)))
	{
		#ifdef _DEBUG
		MessageBox(NULL,"obt@ւ݂̏Ɏs܂!!","vertex buffer ERROR!!",MB_OK);
		#endif	// _DEBUG
		return E_FAIL;
	}


	// obt@bNzAhX擾
	m_pVtxBuffer -> Lock(0,0,(void**)&pVtx,0);				// GPUVRAMւ̑bN


	// _obt@[̐ݒ
	for( int index = 0; index < PARTICLE_MAX; index++ ){

		// _W̐ݒ
		SetVertexCoord( pVtx , index );

		// _F̐ݒ
		SetVertexColor( pVtx , index );

		// _UVl̐ݒ
		SetVertexSpriteUV( pVtx , index );

		// @̐ݒ
		SetVertexNormal( pVtx, index );


	} // ->VTX SETTING END

	// obt@̃AbN
	m_pVtxBuffer->Unlock( );

	return S_OK;

}

// p[eBNWݒu
void KSumiGame::SetVertexCoord( VERTEX_3D *pVtx , const int index )
{

	
	D3DXVECTOR2 start,end;			//n_ƏI_


	// WvZparticle
	start.x = -m_aParticle[ index ].radius;
	start.y = +m_aParticle[ index ].radius;
	end.x   = +m_aParticle[ index ].radius;
	end.y   = -m_aParticle[ index ].radius;


	// _W̐ݒ
	pVtx[ 0 + (index * NUM_VERTEX) ].pos = D3DXVECTOR3( start.x, start.y, 0.0f);
	pVtx[ 1 + (index * NUM_VERTEX) ].pos = D3DXVECTOR3( end.x,   start.y, 0.0f);
	pVtx[ 2 + (index * NUM_VERTEX) ].pos = D3DXVECTOR3( start.x, end.y,   0.0f);
	pVtx[ 3 + (index * NUM_VERTEX) ].pos = D3DXVECTOR3( end.x,   end.y,   0.0f);

}

// p[eBNFύX֐
void KSumiGame::SetVertexColor( VERTEX_3D *pVtx , const int index )
{
	
	// ̕ύX
	pVtx[ 0 + (index * NUM_VERTEX) ].color = m_aParticle[ index ].color;
	pVtx[ 1 + (index * NUM_VERTEX) ].color = m_aParticle[ index ].color;
	pVtx[ 2 + (index * NUM_VERTEX) ].color = m_aParticle[ index ].color;
	pVtx[ 3 + (index * NUM_VERTEX) ].color = m_aParticle[ index ].color;
	

}

void KSumiGame::SetVertexNormal( VERTEX_3D* pVtx, const int index )
{

	pVtx[0 + NUM_VERTEX*index ].normal = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	pVtx[1 + NUM_VERTEX*index ].normal = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	pVtx[2 + NUM_VERTEX*index ].normal = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	pVtx[3 + NUM_VERTEX*index ].normal = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );

}


// p[eBNUVl̃Zbg
void KSumiGame::SetVertexSpriteUV( VERTEX_3D *pVtx , const int index  )
{

	pVtx[ 0 + (index * NUM_VERTEX) ].tex = D3DXVECTOR2( 0.0f, 0.0f );
	pVtx[ 1 + (index * NUM_VERTEX) ].tex = D3DXVECTOR2( 1.0f, 0.0f );
	pVtx[ 2 + (index * NUM_VERTEX) ].tex = D3DXVECTOR2( 0.0f, 1.0f );
	pVtx[ 3 + (index * NUM_VERTEX) ].tex = D3DXVECTOR2( 1.0f, 1.0f );

}

// p[eBN(I[_)
void KSumiGame::SetParticle( const D3DXVECTOR3 center , int DasuKazu )
{
	int DasitaKazu = 0;

	// q̐ݒu
	for( int index = 0; index < PARTICLE_MAX; index++ ){

		if( !m_aParticle[ index ].life )
		{
			

			{ // p[eBNp[^[̐ݒ


				// p[eBNSW
				m_aParticle[ index ].center   = center;

				// p[eBN̑x
				//m_aParticle[ index ].speed    = D3DXVECTOR3( ((rand()%100)-50)*0.01f, ((rand()%100)-50)*0.01f, ((rand()%100)-50)*0.01f ); 
				m_aParticle[ index ].speed    = D3DXVECTOR3( 0.5f , 0.5f , 0.5f );

				// p[eBN̉x
				m_aParticle[ index ].velocity = D3DXVECTOR3( 0.98f , 0.98f , 0.98f );

				// p[eBNopxݒ
				m_aParticle[ index ].theta   = ((( rand( )%628 ) + 157 ) - 314 ) * 0.01f;
				m_aParticle[ index ].phy     = ((( rand( )%628 ) + 314 ) - 314 + 157 ) * 0.01f;

				// p[eBNF̐ݒ
				m_aParticle[ index ].color    = D3DXCOLOR( 1.0f , 1.0f , 1.0f , 1.0f );

				// p[eBNa
				m_aParticle[ index ].radius   =  10.0f;

				// p[eBN̑݃t[
				m_aParticle[ index ].life     =  60.0f;				

				// p[eBNωʒ萔
				m_aParticle[ index ].amountOfChangeInColor.a  = m_aParticle[ index ].color.a / m_aParticle[ index ].life;
				m_aParticle[ index ].amountOfChangeInColor.a  *= 0.1f;
				m_aParticle[ index ].amountOfChangeInColor.r  = m_aParticle[ index ].color.r / m_aParticle[ index ].life;
				m_aParticle[ index ].amountOfChangeInColor.g  = m_aParticle[ index ].color.g / m_aParticle[ index ].life;
				m_aParticle[ index ].amountOfChangeInColor.b  = m_aParticle[ index ].color.b / m_aParticle[ index ].life;
				m_aParticle[ index ].amountOfChangeInRadius   = m_aParticle[ index ].radius /  m_aParticle[ index ].life;
			
				DasitaKazu++;

			} // -> END ( PARTICLE SET )

			if( DasitaKazu <= DasuKazu  )
			{
				break;
			}
		}
	}

}
